# domainBAPI接口说明

## 接口1: 路由查询

- 实现细节：

基本透传结果，需要注意非联通号码返回信息不同

```http
POST HTTP://127.0.0.1:12091/domainB/api/route/
Content-Type: application/json

{
  "phoneNumber": "18503369666",
  "fromSystem": "test"
}
```

```json
{
  "success": true,
  "code": 200,
  "message": "成功",
  "data": {
    "phoneNumber": "18503369666",
    "isUnicomNumber": true,
    "userStatus": "2",
    "routeType": "00",
    "eparchyCode": "0335",
    "provinceCode": "18"
  }
}
```

### 输出参数说明

phoneNumber：手机号

isUnicomNumber：是否联通号码

userStatus： 用户状态；1：drds 号码在用状态 且为新架构号码 2：oracle 号码在用状态 且为cBss常态化号码 3：非CB 号码在cBss系统没有路由记录 4：drds 号码失效状态 且为新架构号码 5：oracle 号码失效状态 且为cBss常态化号码

routeType：路由类型

eparchyCode： 地市编码

provinceCode：省份编码

## 接口2: 5GSA查询

- 实现细节：

需要查询全国用户，因此需要套一层路由查询

```http
POST HTTP://127.0.0.1:12091/domainB/api/sa/
Content-Type: application/json

{
  "phoneNumber": "18503369666",
  "fromSystem": "test"
}
```

```json
{
  "success": true,
  "code": 200,
  "message": "成功",
  "data": {
    "isUnicomNumber": true,
    "isHaveSa": true,
    "isUdmUser": true
  }
}
```

### 5GSA查询接口输出参数说明

isUnicomNumber： 是否联通号码

isHaveSa： 是否有SA服务

isUdmUser： 是否UDM用户

## 接口3: 功能查询

- 实现细节：

由于操作员权限限制，查询仅支持河北联通用户，需要注意处理非河北联通用户及非联通用户的特殊情况

```http
POST HTTP://127.0.0.1:12091/domainB/api/product/saAndVolte/
Content-Type: application/json

{
  "phoneNumber": "18503369666",
  "fromSystem": "test"
}
```

```json
{
  "success": true,
  "code": 200,
  "message": "成功",
  "data": {
    "isHebeiUnicomNumber": true,
    "is5gProduct": true,
    "isHaveSa": true,
    "isHaveVolte": true
  }
}

```

### 功能查询接口输出参数说明

isHebeiUnicomNumber： 是否河北联通号码

is5gProduct： 是否5g套餐

isHaveSa： 是否开通5g

isHaveVolte： 是否开通volte

## 接口4：用户资料三户返回

```http
POST HTTP://127.0.0.1:12091/domainB/api/threePart/userState/
Content-Type: application/json

{
  "phoneNumber": "18503369666",
  "fromSystem": "test"
}
```

```json
{
  "success": true,
  "code": 200,
  "message": "成功",
  "data": {
    "userState": "0"
  }
}
```

### 用户资料三户返回输出参数说明

userState： 用户状态

## 接口5：欠费接口整合

```http
POST HTTP://127.0.0.1:12091/domainB/api/acting/qryowefee/
Content-Type: application/json

{
  "phoneNumber": "18503369666",
  "fromSystem": "test"
}
```

```json
{
  "success": true,
  "code": 200,
  "message": "成功",
  "data": {
    "payFee": "0",
    "balanceFee": "4144",
    "realFee": "12900",
    "creditClass": "B",
    "totalCreditValue": "32250",
    "availableCreditValue": "32794"
  }
}
```

### 欠费接口整合输出参数说明

payFee： 应交金额=费用合计-上次余额,应交金额&gt;=0(往月欠费+实时话费)

balanceFee： 当前余额

realFee： 实时话费

creditClass： 信用等级

totalCreditValue： 用户总信用度

availableCreditValue： 可用额度
