package com.nokia.domainb.capability;

import cn.chinaunicom.open.common.Const;
import cn.chinaunicom.open.nlgxptconnection.COMPConnection;
import cn.chinaunicom.open.nlgxptconnection.COMPConnectionContext;
import cn.chinaunicom.open.nlgxptconnection.impl.COMPJsonConnection;
import org.springframework.http.ResponseEntity;
import org.springframework.web.client.RestTemplate;

import java.util.HashMap;
import java.util.Map;

/*
 * 短信用户投诉分析查询接口
 * json_chinaUnicom_hb18_complaintManagement_usercomplaintQuerys
 */
public class UsercomplaintQuerys extends AbstractQuery {
    private static final String URL_DIRECT = "http://133.96.94.184:47996/ete/v1/rest/openApi/usercomplaintQuerys";
    private static final String URL_TEST_DIRECT = "http://133.96.94.185:47996/ete/v1/rest/openApi/usercomplaintQuerys";
    private static final String url = "http://10.245.50.26:8000/api/chinaUnicom/hb18/complaintManagement/usercomplaintQuerys/v1";
    private static final String urlTest = "http://10.124.150.230:8000/api/chinaUnicom/hb18/complaintManagement/usercomplaintQuerys/v1";

    public String queryDirect(String mobile, String destAddr, String complaintType, String isMobile,
            String flowNo, String beginTime, String endTime, String token, boolean test) {
        String realUrl = test ? URL_TEST_DIRECT : URL_DIRECT;
        // REQ
        Map<String, Object> req = new HashMap<>();
        req.put("mobile", mobile);
        req.put("destAddr", destAddr);
        req.put("complaintType", complaintType);
        req.put("isMobile", isMobile);
        req.put("flowNo", flowNo);
        req.put("beginTime", beginTime);
        req.put("endTime", endTime);
        req.put("token", token);
        RestTemplate restTemplate = new RestTemplate();
        ResponseEntity<String> response = restTemplate.postForEntity(realUrl, req, String.class);
        return response.getBody();
    }

    public String queryDirect(Map req, boolean test) {
        String realUrl = test ? URL_TEST_DIRECT : URL_DIRECT;
        RestTemplate restTemplate = new RestTemplate();
        ResponseEntity<String> response = restTemplate.postForEntity(realUrl, req, String.class);
        return response.getBody();
    }

    public COMPConnectionContext query(String mobile, String destAddr, String complaintType, String isMobile,
                                       String flowNo, String beginTime, String endTime, String token, boolean test) {
        String realAppSecret = test ? appSecretTest : appSecret;
        String realUrl = test ? urlTest : url;
        COMPConnection compConnection = new COMPJsonConnection(appId, realAppSecret);

        // REQ
        Map<String, Object> req = new HashMap<>();

        Map<String, Object> userComplaintQuerysReq = new HashMap<>();
        req.put("USERCOMPLAINT_QUERYS_REQ", userComplaintQuerysReq);

        userComplaintQuerysReq.put("mobile", mobile);
        userComplaintQuerysReq.put("destAddr", destAddr);
        userComplaintQuerysReq.put("complaintType", complaintType);
        userComplaintQuerysReq.put("isMobile", isMobile);
        userComplaintQuerysReq.put("flowNo", flowNo);
        userComplaintQuerysReq.put("beginTime", beginTime);
        userComplaintQuerysReq.put("endTime", endTime);
        userComplaintQuerysReq.put("token", token);

        return compConnection.excute(Const.HttpMethodType.POST, realUrl, req, false);
    }

    public COMPConnectionContext query(Map map, boolean test) {
        String realAppSecret = test ? appSecretTest : appSecret;
        String realUrl = test ? urlTest : url;
        COMPConnection compConnection = new COMPJsonConnection(appId, realAppSecret);
        Map<String, Object> req = new HashMap<>();
        req.put("USERCOMPLAINT_QUERYS_REQ", map);
        return compConnection.excute(Const.HttpMethodType.POST, realUrl, req, false);
    }
}
