package com.nokia.domainb.config;

import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.concurrent.CustomizableThreadFactory;

import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

@Slf4j
@Configuration
public class ThreadPoolConfig {
    /**
     * 欠费接口整合线程池配置
     */
    @Bean
    public ThreadPoolExecutor qryowefeeExecutor() {
        ThreadPoolExecutor executor = new ThreadPoolExecutor(100, 200, 0L, TimeUnit.MILLISECONDS,
                new ArrayBlockingQueue<>(10000), new CustomizableThreadFactory("qryowefee-"));
        executor.prestartAllCoreThreads();
        log.info("qryowefee poolSize: {}", executor.getPoolSize());
        return executor;
    }
}
