package com.nokia.domainb.capability;

import de.siegmar.fastcsv.reader.CsvReader;
import de.siegmar.fastcsv.reader.CsvRow;
import de.siegmar.fastcsv.writer.CsvWriter;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.web.client.RestTemplate;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;

@Slf4j
class ApiTest {
    public static final String TEST_DIR = "test/";

    @Test
    void test() {
    }

    /**
     * 投诉系统注册的客户手机号对应的手机终端类型
     */
    @Test
    void testNr() {
        String url = "http://192.168.70.130:12010/nr.php?id=";
        // 数据文件路径
        String dataPath = TEST_DIR + "data.csv";
        // 结果保存的路径
        String resultPath = TEST_DIR + "result/nr/";
        // 创建文件夹
        try {
            Files.createDirectories(Paths.get(resultPath));
        } catch (IOException e) {
            log.error("创建文件夹失败: {}", e.getMessage(), e);
            return;
        }
        resultPath = resultPath + "result.csv";
        try (CsvReader reader = CsvReader.builder().build(Paths.get(dataPath), Charset.forName("gbk"));
             OutputStreamWriter osw = new OutputStreamWriter(Files.newOutputStream(Paths.get(resultPath)),
                     "gbk");
             CsvWriter writer = CsvWriter.builder().build(osw)
        ) {
            for (CsvRow row : reader) {
                String phone = row.getField(3);
                System.out.println(row.getOriginalLineNumber() + ": " + phone);
                String r;
                try {
                    RestTemplate template = new RestTemplate();
                    r = template.getForObject(url + phone, String.class);
                } catch (Exception e) {
                    log.error(e.getMessage(), e);
                    r = e.getMessage();
                }
                writer.writeRow(phone, r);
            }
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
    }
}
